Package com.sas.services.information.metadata

# Interface PropertyInterface

All Superinterfaces:
  `AbstractPropertyInterface`, `MetadataInterface`, `PublicObjectInterface`, `Remote`

public interface PropertyInterface extends AbstractPropertyInterface
This is a simple interface for representing properties that are coming from a metadata repository.

Since:
  1.0

- ## Field Summary

  ### Fields inherited from interface com.sas.services.information.metadata.MetadataInterface

  `METADATA_STATE_DELETED, METADATA_STATE_DESTROYED, METADATA_STATE_NEW, METADATA_STATE_NORMAL, PERMISSION_READMETADATA, PERMISSION_WRITEMETADATA`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `MetadataInterface`
  `getAssociatedObject()`
  This is a convenience method to get the object that this property is associated with.
  `TextStoreInterface`
  `getConfigurationText()`
  Get the configuration text.
  `String`
  `getDelimiter()`
  Get the delimiter string for the property.
  `String`
  `getKey()`
  Gets the property key.
  `int`
  `getSQLType()`
  Get the SQL type for this property.
  `String`
  `getValue()`
  Gets the value for this property.
  `boolean`
  `isUpdateable()`
  Get the indicator of whether this property should be updateable by a user.
  `void`
  `setConfigurationText(TextStoreInterface textStore)`
  Set the text store object that contains the configuration text for this property.
  `void`
  `setDelimiter(String delimiter)`
  Set the delimiter string on the property.
  `void`
  `setKey(String key)`
  Set the key for this property.
  `void`
  `setSQLType(int type)`
  Set the SQL type for this property.
  `void`
  `setUpdateable(boolean isUpdateable)`
  Set the flag indicating if this property should be updateable by a user.
  `void`
  `setValue(String value)`
  Set the value for this property.

  ### Methods inherited from interface com.sas.services.information.metadata.AbstractPropertyInterface

  `addCustomizer, addEditor, addValidator, getAssociatedPropertyGroup, getCustomizers, getEditors, getIsExpert, getIsLinked, getIsRequired, getIsUpdateable, getIsVisible, getStoredConfiguration, getValidators, removeCustomizer, removeEditor, removeValidator, setAssociatedPropertyGroup, setIsExpert, setIsLinked, setIsRequired, setIsUpdateable, setIsVisible, setStoredConfiguration`

  ### Methods inherited from interface com.sas.services.information.metadata.MetadataInterface

  `add, addAccessControl, addAttribute, addAttributes, addDocument, addExtension, addGroup, addImplementor, addKeyword, addNoteTextStore, addNoteTextStore, addObjectProperty, addObjectProperty, addPermissions, addPrompt, addPropertySet, addRemark, addResponsibleParty, addTransactionListener, addUsedByPrototype, checkin, checkout, commit, copyTo, countAssociatedObjects, delete, deleteAttribute, deleteAttributes, destroy, getAccessControls, getAttribute, getAttributes, getAuthorizationUtil, getCreateDate, getCreatedBy, getDescription, getDocuments, getEntityKey, getEntityURL, getExtensions, getGroups, getGUID, getIdentities, getImplementors, getKeywords, getLockedBy, getModifiedBy, getModifyDate, getNoteTextStore, getNoteTextStores, getNoteTextStoresByRole, getObjectProperties, getParent, getParentPath, getParents, getPath, getPaths, getPermission, getPermissions, getPermissions, getPreviousVersionNames, getPrimaryPropertyGroup, getPrompt, getPrompts, getPropertyBag, getPropertySets, getRemarksList, getReposId, getRepository, getRepositoryEntity, getRepositoryName, getReposKey, getResponsibleParties, getState, getTrackingId, getType, getUsageVersion, getUsedByPrototypes, getUsingPrototype, getVersion, isAuthorized, isCompatible, isDeleted, isDestroyed, isObjectAlive, isReadCompatible, mapNameToFilesystem, mapUrlToFilesystem, moveTo, newServiceObject, refresh, removeAccessControl, removeDocument, removeExtension, removeGroup, removeImplementor, removeKeyword, removeNoteTextStore, removeObjectProperty, removePermissions, removePrompt, removePropertySet, removeResponsibleParty, removeResponsiblePartyByIdentity, removeUsedByPrototype, rollback, setAttribute, setAttributes, setDeleted, setDescription, setDocuments, setExtensions, setGroups, setGUID, setKeywords, setName, setNoteTextStores, setObjectProperties, setPermission, setPrimaryPropertyGroup, setPrompt, setPrompts, setRemarksList, setRepository, setUsingPrototype, startTransaction, toByteArray, transactionEvent, uncheckout, update, updateFromBag, version`

  ### Methods inherited from interface com.sas.services.information.publicobject.PublicObjectInterface

  `addProcessorInterface, getContainer, getIdentifier, getName, getObjectURI, getPathUrl, getProcessorInterface, getTypeDescriptor`

- ## Method Details

  - ### getKey

    String getKey() throws ServiceException, RemoteException
    Gets the property key.

    Returns:
      A String with the key for this property.
    Throws:
      `ServiceException` - If a service level error occurs.
      `RemoteException` - in the event of remote object failure.

  - ### setKey

    void setKey(String key) throws ServiceException, RemoteException
    Set the key for this property. This will set the PropertyName attribute in OMR.
    Parameters:
      `key` - the new Key to set on this property.
    Throws:
      `ServiceException` - If a repository error or service level exception occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getValue

    String getValue() throws ServiceException, RemoteException
    Gets the value for this property.

    Returns:
      A String with the value for this property.
    Throws:
      `ServiceException` - If a service level error occurs.
      `RemoteException` - in the event of remote object failure.

  - ### setValue

    void setValue(String value) throws ServiceException, RemoteException
    Set the value for this property.
    Parameters:
      `value` - The new value to set.
    Throws:
      `ServiceException` - If a repository or service level exception occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getSQLType

    int getSQLType() throws ServiceException, RemoteException
    Get the SQL type for this property. This will be in numeric form.

    Returns:
      The SQL type code.
    Throws:
      `ServiceException` - If a service level error occurs.
      `RemoteException` - in the event of remote object failure.

  - ### setSQLType

    void setSQLType(int type) throws ServiceException, RemoteException
    Set the SQL type for this property.
    Parameters:
      `type` - A standard SQL type that indicates the type of this property value.
    Throws:
      `ServiceException` - If a repository or service level exception occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getConfigurationText

    TextStoreInterface getConfigurationText() throws ServiceException, RemoteException
    Get the configuration text. If this is not stored in a TextStore object, the current implementation will return a null.
    Returns:
      A TextStoreInterface representing the TextStore object.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setConfigurationText

    void setConfigurationText(TextStoreInterface textStore) throws ServiceException, RemoteException
    Set the text store object that contains the configuration text for this property.
    Parameters:
      `textStore` - The text store object containing the configuration text for this property.
    Throws:
      `ServiceException` - If a repository error or service level exception occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setDelimiter

    void setDelimiter(String delimiter) throws ServiceException, RemoteException
    Set the delimiter string on the property.
    Parameters:
      `delimiter` - The String to use as a delimiter for the property.
    Throws:
      `ServiceException` - If a service level error occurs.
      `RemoteException` - In the event of a remote object failure.

  - ### getDelimiter

    String getDelimiter() throws ServiceException, RemoteException
    Get the delimiter string for the property.
    Returns:
      The property's delimiter string.
    Throws:
      `ServiceException` - If a service level error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getAssociatedObject

    MetadataInterface getAssociatedObject() throws ServiceException, RemoteException
    This is a convenience method to get the object that this property is associated with. To set the associated object, use MetadataInterface.addObjectProperty.
    Returns:
      The metadata object this Property is associated with.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object faiure.

  - ### isUpdateable

    boolean isUpdateable() throws ServiceException, RemoteException
    Get the indicator of whether this property should be updateable by a user. This flag is a metadata attribute, and in no way reflects permission settings. It is the application's responsibility to enforce this flag, if it wishes to do so.
    Returns:
      True if the property is user-updateable, false otherwise.
    Throws:
      `ServiceException` - In the event of metadata server failure.
      `RemoteException` - In the event of remote object failure.

  - ### setUpdateable

    void setUpdateable(boolean isUpdateable) throws ServiceException, RemoteException
    Set the flag indicating if this property should be updateable by a user. This setting is not enforced by Information Services, and has to be handled by the application if it wishes to set this flag and honor it.
    Parameters:
      `isUpdateable` - A boolean indicating if the property should be user-updateable.
    Throws:
      `ServiceException` - If a metadata server failure occurs.
      `RemoteException` - In the event of remote object failure.